#include "morfofun.hh"
#include "verbimorfo.hh"
#include "nominimorfo.hh"

class VerbiStruct
{
public:
	string mask;
	
	string indpre[8];
	string indimp[7];
	string kon[8];
	string johd[6];
	string pot[9]; // yks1, yks2, yks3, mon1, mon2, mon3, pass, !pass, !akt
	string imp[9], opt[9];
	string inf1, inf2, inf3akt, inf3pas, inf4, inf5;
	string psi1akt, psi1pas;
	string psi2akt, psi2pas;
	string medakt, medpas;
	string pers;
	
	/*
		MEDiaali, OPTatiivi: NOT IMPLEMENTED YET
	*/
	
	void set(const string &hdr, const vector<string> &tab)
	{
		if(!tab.size())return;
		if(hdr == "1inf") { inf1 = tab[0]; return; }
		if(hdr == "2inf") { inf2 = tab[0]; return; }
		if(hdr == "3inf") { inf3akt = tab[0]; inf3pas = tab[1]; return; }
		if(hdr == "4inf") { inf4 = tab[0]; return; }
		if(hdr == "5inf") { inf5 = tab[0]; return; }
		if(hdr == "Pers") { pers = tab[0]; return; }
		if(hdr == "1psi") { psi1akt = tab[0]; psi1pas = tab[1]; return; }
		if(hdr == "2psi") { psi2akt = tab[0]; psi2pas = tab[1]; return; }
		if(hdr == "Kon") { for(unsigned a=0; a<tab.size(); ++a)if(a < 8)kon[a] = tab[a]; return; }
		if(hdr == "Pot") { for(unsigned a=0; a<tab.size(); ++a)if(a < 9)pot[a] = tab[a]; return; }
		if(hdr == "Imp") { for(unsigned a=0; a<tab.size(); ++a)if(a < 9)imp[a] = tab[a]; return; }
		if(hdr == "Opt") { for(unsigned a=0; a<tab.size(); ++a)if(a < 9)opt[a] = tab[a]; return; }
		if(hdr == "Johd") { for(unsigned a=0; a<tab.size(); ++a)if(a < 6)johd[a] = tab[a]; return; }
		if(hdr == "Med") { medakt = tab[0]; medpas = tab[1]; return; }
		if(hdr == "Ind")
		{
			for(unsigned a=0; a<tab.size(); ++a)
			{
				if(a < 7)indpre[a] = tab[a];
				else if(a < 14)indimp[a-7] = tab[a];
				else if(a == 14)indpre[7] = tab[a];
			}
			return;
		}
	}
	
	void clear()
	{
		mask.erase();
		for(unsigned a=0; a<8; ++a) { indpre[a].erase(); kon[a].erase(); }
		for(unsigned a=0; a<7; ++a)indimp[a].erase();
		for(unsigned a=0; a<6; ++a)johd[a].erase();
		for(unsigned a=0; a<9; ++a) { pot[a].erase(); imp[a].erase(); opt[a].erase(); }
		inf1.erase(); inf2.erase(); inf3akt.erase(); inf3pas.erase(); inf4.erase(); inf5.erase();
		psi1akt.erase(); psi1pas.erase();
		psi2akt.erase(); psi2pas.erase();
		medakt.erase(); medpas.erase();
		pers.erase();
	}
	
	const string Replace(const string &word, const string &pat) const
	{
		return ::Replace(word, mask, pat);
	}
};

static Struktit<VerbiStruct> VerbiStruktit("verbiruumiit.txt", "verbi");

static bool monipers(persoona pers)
{
	return pers == MON1 || pers == MON2 || pers == MON3;
}

const string Indikatiiviksi(const string &word, aikamuoto aika, persoona pers, bool polariteetti)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	/* Oikein */
	switch(aika)
	{
		case PREESENS:
			if(!polariteetti)
				if(pers==PASSIIVI)return Indikatiiviksi("ei", PREESENS, pers) + " "
				                       + str.Replace(word, str.indpre[NEGPASS]);
				else return Indikatiiviksi("ei", PREESENS, pers) + " "
				          + Imperatiiviksi(word, PREESENS, YKS2);
			return str.Replace(word, str.indpre[pers]);
		case IMPERFEKTI:
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " " + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
			return str.Replace(word, str.indpre[pers]);
		case PERFEKTI:
			if(!polariteetti)
				if(pers==PASSIIVI)return Indikatiiviksi("ei", PREESENS, pers) + " "
				                       + Imperatiiviksi("olla", PREESENS, YKS2) + " "
				                       + Partisiipiksi2(word, true, false);
				else return Indikatiiviksi("ei", PREESENS, pers) + " "
				          + Imperatiiviksi("olla", PREESENS, YKS2) + " "
				          + Partisiipiksi2(word, false, monipers(pers));
			return Indikatiiviksi("olla", PREESENS, pers==PASSIIVI ? YKS3 : pers) + " "
			     + Partisiipiksi2(word, false, monipers(pers));
		case PLUSKVAMPERFEKTI:
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " " 
			                      + Partisiipiksi2("olla", false, monipers(pers)) + " "
			                      + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
			return Indikatiiviksi("olla", IMPERFEKTI, pers==PASSIIVI ? YKS3 : pers) + " "
			     + Partisiipiksi2(word, false, monipers(pers));
	}
	return "?ind:"+word;
}

const string Konditionaaliksi(const string &word, aikamuoto aika, persoona pers, bool polariteetti)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	/* Oikein */
	switch(aika)
	{
		case PREESENS:
			/* Pos: liputtaisin / liputettaisiin
			 * Neg: en liputtaisi / ei liputettaisi
			 */
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " "
			                      + str.Replace(word, str.kon[pers==PASSIIVI ? NEGPASS : YKS3]);
			return str.Replace(word, str.kon[pers]);
		case PERFEKTI:
			/* Pos: olisin liputtanut / olisi liputettu
			 * Neg: en olisi liputtanut / ei olisi liputettu
			 */		     
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " "
			                      + Konditionaaliksi("olla", PREESENS, YKS3) + " "
			                      + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
			return Konditionaaliksi("olla", PREESENS, pers==PASSIIVI ? YKS3 : pers) + " "
			     + Partisiipiksi2(word, false, monipers(pers));
		case IMPERFEKTI:
		case PLUSKVAMPERFEKTI:
			fprintf(stderr, "'%s': %s ei ole imperfektille eik pluskvamperfektille.\n", word.c_str(), "Konditionaalia");
	}
	return "?cond:"+word;
}

const string Potentiaaliksi(const string &word, aikamuoto aika, persoona pers, bool polariteetti)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	/* Oikein */
	switch(aika)
	{
		case PREESENS:
			/* Pos: liputtanen / liputettaneen
			 * Neg: en liputtane / ei liputettane
			 */
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " "
			                      + str.Replace(word, str.pot[pers==PASSIIVI ? NEGPASS : NEGAKT]);
			return str.Replace(word, str.pot[pers]);
		case PERFEKTI:
			/* Pos: lienen liputtanut / lienee liputettu
			 * Neg: en liene liputtanut / ei liene liputettu
			 */
			if(!polariteetti)return Indikatiiviksi("ei", PREESENS, pers) + " "
			                      + Potentiaaliksi("olla", PREESENS, NEGAKT) + " "
			                      + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
			return Potentiaaliksi("olla", PREESENS, pers) + " "
			     + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
		case IMPERFEKTI:
		case PLUSKVAMPERFEKTI:
			fprintf(stderr, "'%s': %s ei ole imperfektille eik pluskvamperfektille.\n", word.c_str(), "Potentiaalia");
	}
	return "?pot:"+word;
}

const string Imperatiiviksi(const string &word, aikamuoto aika, persoona pers, bool polariteetti)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	/* Oikein */
	if(pers == YKS1)
		fprintf(stderr, "'%s': %s ei ole yksikn ensimmiselle persoonalle.\n", word.c_str(), "Imperatiivia");
	switch(aika)
	{
		case PREESENS:
			/* Pos: liputa / liputettakoon
			 * Neg: l liputa / lkn liputettako
			 */
			if(!polariteetti)return Imperatiiviksi("ei", PREESENS, pers) + " "
			                      + str.Replace(word, str.imp[pers==YKS2 ? pers
			                                               : (pers==PASSIIVI ? NEGPASS : NEGAKT)]);
			return str.Replace(word, str.imp[pers]);
		case PERFEKTI:
			/* Pos: ole liputtanut / olkoon liputettu
			 * Neg: l ole liputtanut / lkn olko liputettu
			 */
			if(!polariteetti)return Imperatiiviksi("ei", PREESENS, pers) + " "
			                      + Imperatiiviksi("olla", PREESENS, (pers==YKS2 || pers==YKS1) ? pers
			                                                      : NEGAKT) + " "
			                      + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
			return Imperatiiviksi("olla", PREESENS, pers) + " "
			     + Partisiipiksi2(word, pers==PASSIIVI, monipers(pers));
		case IMPERFEKTI:
		case PLUSKVAMPERFEKTI:
			fprintf(stderr, "'%s': %s ei ole imperfektille eik pluskvamperfektille.\n", word.c_str(), "Imperatiivia");
	}
	return "?imp:"+word;
}

const string Infinitiiviksi1(const string &word)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, str.inf1);
}

const string Infinitiiviksi2(const string &word)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, str.inf2);
}

const string Infinitiiviksi3(const string &word, bool passiivi)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, passiivi ? str.inf3pas : str.inf3akt);
}

const string Infinitiiviksi4(const string &word)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, str.inf4);
}

const string Infinitiiviksi5(const string &word)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, str.inf5);
}

const string Partisiipiksi1(const string &word, bool passiivi)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, passiivi ? str.psi1pas : str.psi1akt);
}

const string Partisiipiksi2(const string &word, bool passiivi, bool monikko)
{
	if(monikko)
		return NominiTaivutus(Partisiipiksi2(word, passiivi), NOMINATIIVI, true, PASSIIVI);
	
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, passiivi ? str.psi2pas : str.psi2akt);
}

const string Mediaaliksi(const string &word, bool passiivi)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, passiivi ? str.medpas : str.medakt);
}

const string Suorittajaksi(const string &word)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	return str.Replace(word, str.pers);
}

const string JohdaVerbi(const string &word, tapaluokka tapa)
{
	const VerbiStruct &str = VerbiStruktit.find(word);
	switch(tapa)
	{
		case JOHTO1: return str.Replace(word, str.johd[0]);
		case JOHTO2: return str.Replace(word, str.johd[1]);
		case JOHTO3: return str.Replace(word, str.johd[2]);
		case JOHTO4: return str.Replace(word, str.johd[3]);
		case JOHTO5: return str.Replace(word, str.johd[4]);
		case JOHTO6: return str.Replace(word, str.johd[5]);
	}
	return "?johto:"+word;
}
